import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppsyncResolverConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#api_id AppsyncResolver#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#data_source AppsyncResolver#data_source}.
     *
     * @stability stable
     */
    readonly dataSource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#field AppsyncResolver#field}.
     *
     * @stability stable
     */
    readonly field: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#kind AppsyncResolver#kind}.
     *
     * @stability stable
     */
    readonly kind?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#request_template AppsyncResolver#request_template}.
     *
     * @stability stable
     */
    readonly requestTemplate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#response_template AppsyncResolver#response_template}.
     *
     * @stability stable
     */
    readonly responseTemplate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#type AppsyncResolver#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * caching_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#caching_config AppsyncResolver#caching_config}
     *
     * @stability stable
     */
    readonly cachingConfig?: AppsyncResolverCachingConfig[];
    /**
     * pipeline_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#pipeline_config AppsyncResolver#pipeline_config}
     *
     * @stability stable
     */
    readonly pipelineConfig?: AppsyncResolverPipelineConfig[];
}
/**
 * @stability stable
 */
export interface AppsyncResolverCachingConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#caching_keys AppsyncResolver#caching_keys}.
     *
     * @stability stable
     */
    readonly cachingKeys?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#ttl AppsyncResolver#ttl}.
     *
     * @stability stable
     */
    readonly ttl?: number;
}
/**
 * @stability stable
 */
export interface AppsyncResolverPipelineConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html#functions AppsyncResolver#functions}.
     *
     * @stability stable
     */
    readonly functions?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html aws_appsync_resolver}.
 *
 * @stability stable
 */
export declare class AppsyncResolver extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appsync_resolver.html aws_appsync_resolver} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncResolverConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    resetDataSource(): void;
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _field;
    /**
     * @stability stable
     */
    get field(): string;
    /**
     * @stability stable
     */
    set field(value: string);
    /**
     * @stability stable
     */
    get fieldInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kind?;
    /**
     * @stability stable
     */
    get kind(): string;
    /**
     * @stability stable
     */
    set kind(value: string);
    /**
     * @stability stable
     */
    resetKind(): void;
    /**
     * @stability stable
     */
    get kindInput(): string | undefined;
    private _requestTemplate?;
    /**
     * @stability stable
     */
    get requestTemplate(): string;
    /**
     * @stability stable
     */
    set requestTemplate(value: string);
    /**
     * @stability stable
     */
    resetRequestTemplate(): void;
    /**
     * @stability stable
     */
    get requestTemplateInput(): string | undefined;
    private _responseTemplate?;
    /**
     * @stability stable
     */
    get responseTemplate(): string;
    /**
     * @stability stable
     */
    set responseTemplate(value: string);
    /**
     * @stability stable
     */
    resetResponseTemplate(): void;
    /**
     * @stability stable
     */
    get responseTemplateInput(): string | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _cachingConfig?;
    /**
     * @stability stable
     */
    get cachingConfig(): AppsyncResolverCachingConfig[];
    /**
     * @stability stable
     */
    set cachingConfig(value: AppsyncResolverCachingConfig[]);
    /**
     * @stability stable
     */
    resetCachingConfig(): void;
    /**
     * @stability stable
     */
    get cachingConfigInput(): AppsyncResolverCachingConfig[] | undefined;
    private _pipelineConfig?;
    /**
     * @stability stable
     */
    get pipelineConfig(): AppsyncResolverPipelineConfig[];
    /**
     * @stability stable
     */
    set pipelineConfig(value: AppsyncResolverPipelineConfig[]);
    /**
     * @stability stable
     */
    resetPipelineConfig(): void;
    /**
     * @stability stable
     */
    get pipelineConfigInput(): AppsyncResolverPipelineConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
