import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#adjustment_type AutoscalingPolicy#adjustment_type}.
     *
     * @stability stable
     */
    readonly adjustmentType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#autoscaling_group_name AutoscalingPolicy#autoscaling_group_name}.
     *
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#cooldown AutoscalingPolicy#cooldown}.
     *
     * @stability stable
     */
    readonly cooldown?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#estimated_instance_warmup AutoscalingPolicy#estimated_instance_warmup}.
     *
     * @stability stable
     */
    readonly estimatedInstanceWarmup?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_aggregation_type AutoscalingPolicy#metric_aggregation_type}.
     *
     * @stability stable
     */
    readonly metricAggregationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#min_adjustment_magnitude AutoscalingPolicy#min_adjustment_magnitude}.
     *
     * @stability stable
     */
    readonly minAdjustmentMagnitude?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#name AutoscalingPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#policy_type AutoscalingPolicy#policy_type}.
     *
     * @stability stable
     */
    readonly policyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#scaling_adjustment AutoscalingPolicy#scaling_adjustment}.
     *
     * @stability stable
     */
    readonly scalingAdjustment?: number;
    /**
     * predictive_scaling_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predictive_scaling_configuration AutoscalingPolicy#predictive_scaling_configuration}
     *
     * @stability stable
     */
    readonly predictiveScalingConfiguration?: AutoscalingPolicyPredictiveScalingConfiguration[];
    /**
     * step_adjustment block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#step_adjustment AutoscalingPolicy#step_adjustment}
     *
     * @stability stable
     */
    readonly stepAdjustment?: AutoscalingPolicyStepAdjustment[];
    /**
     * target_tracking_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#target_tracking_configuration AutoscalingPolicy#target_tracking_configuration}
     *
     * @stability stable
     */
    readonly targetTrackingConfiguration?: AutoscalingPolicyTargetTrackingConfiguration[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedLoadMetricSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_type AutoscalingPolicy#predefined_metric_type}.
     *
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#resource_label AutoscalingPolicy#resource_label}.
     *
     * @stability stable
     */
    readonly resourceLabel: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedMetricPairSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_type AutoscalingPolicy#predefined_metric_type}.
     *
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#resource_label AutoscalingPolicy#resource_label}.
     *
     * @stability stable
     */
    readonly resourceLabel: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedScalingMetricSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_type AutoscalingPolicy#predefined_metric_type}.
     *
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#resource_label AutoscalingPolicy#resource_label}.
     *
     * @stability stable
     */
    readonly resourceLabel: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyPredictiveScalingConfigurationMetricSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#target_value AutoscalingPolicy#target_value}.
     *
     * @stability stable
     */
    readonly targetValue: number;
    /**
     * predefined_load_metric_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_load_metric_specification AutoscalingPolicy#predefined_load_metric_specification}
     *
     * @stability stable
     */
    readonly predefinedLoadMetricSpecification?: AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedLoadMetricSpecification[];
    /**
     * predefined_metric_pair_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_pair_specification AutoscalingPolicy#predefined_metric_pair_specification}
     *
     * @stability stable
     */
    readonly predefinedMetricPairSpecification?: AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedMetricPairSpecification[];
    /**
     * predefined_scaling_metric_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_scaling_metric_specification AutoscalingPolicy#predefined_scaling_metric_specification}
     *
     * @stability stable
     */
    readonly predefinedScalingMetricSpecification?: AutoscalingPolicyPredictiveScalingConfigurationMetricSpecificationPredefinedScalingMetricSpecification[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyPredictiveScalingConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#max_capacity_breach_behavior AutoscalingPolicy#max_capacity_breach_behavior}.
     *
     * @stability stable
     */
    readonly maxCapacityBreachBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#max_capacity_buffer AutoscalingPolicy#max_capacity_buffer}.
     *
     * @stability stable
     */
    readonly maxCapacityBuffer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#mode AutoscalingPolicy#mode}.
     *
     * @stability stable
     */
    readonly mode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#scheduling_buffer_time AutoscalingPolicy#scheduling_buffer_time}.
     *
     * @stability stable
     */
    readonly schedulingBufferTime?: string;
    /**
     * metric_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_specification AutoscalingPolicy#metric_specification}
     *
     * @stability stable
     */
    readonly metricSpecification: AutoscalingPolicyPredictiveScalingConfigurationMetricSpecification[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyStepAdjustment {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_interval_lower_bound AutoscalingPolicy#metric_interval_lower_bound}.
     *
     * @stability stable
     */
    readonly metricIntervalLowerBound?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_interval_upper_bound AutoscalingPolicy#metric_interval_upper_bound}.
     *
     * @stability stable
     */
    readonly metricIntervalUpperBound?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#scaling_adjustment AutoscalingPolicy#scaling_adjustment}.
     *
     * @stability stable
     */
    readonly scalingAdjustment: number;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecificationMetricDimension {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#name AutoscalingPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#value AutoscalingPolicy#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_name AutoscalingPolicy#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#namespace AutoscalingPolicy#namespace}.
     *
     * @stability stable
     */
    readonly namespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#statistic AutoscalingPolicy#statistic}.
     *
     * @stability stable
     */
    readonly statistic: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#unit AutoscalingPolicy#unit}.
     *
     * @stability stable
     */
    readonly unit?: string;
    /**
     * metric_dimension block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#metric_dimension AutoscalingPolicy#metric_dimension}
     *
     * @stability stable
     */
    readonly metricDimension?: AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecificationMetricDimension[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationPredefinedMetricSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_type AutoscalingPolicy#predefined_metric_type}.
     *
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#resource_label AutoscalingPolicy#resource_label}.
     *
     * @stability stable
     */
    readonly resourceLabel?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#disable_scale_in AutoscalingPolicy#disable_scale_in}.
     *
     * @stability stable
     */
    readonly disableScaleIn?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#target_value AutoscalingPolicy#target_value}.
     *
     * @stability stable
     */
    readonly targetValue: number;
    /**
     * customized_metric_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#customized_metric_specification AutoscalingPolicy#customized_metric_specification}
     *
     * @stability stable
     */
    readonly customizedMetricSpecification?: AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecification[];
    /**
     * predefined_metric_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html#predefined_metric_specification AutoscalingPolicy#predefined_metric_specification}
     *
     * @stability stable
     */
    readonly predefinedMetricSpecification?: AutoscalingPolicyTargetTrackingConfigurationPredefinedMetricSpecification[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html aws_autoscaling_policy}.
 *
 * @stability stable
 */
export declare class AutoscalingPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_policy.html aws_autoscaling_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingPolicyConfig);
    private _adjustmentType?;
    /**
     * @stability stable
     */
    get adjustmentType(): string;
    /**
     * @stability stable
     */
    set adjustmentType(value: string);
    /**
     * @stability stable
     */
    resetAdjustmentType(): void;
    /**
     * @stability stable
     */
    get adjustmentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingGroupName;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string;
    private _cooldown?;
    /**
     * @stability stable
     */
    get cooldown(): number;
    /**
     * @stability stable
     */
    set cooldown(value: number);
    /**
     * @stability stable
     */
    resetCooldown(): void;
    /**
     * @stability stable
     */
    get cooldownInput(): number | undefined;
    private _estimatedInstanceWarmup?;
    /**
     * @stability stable
     */
    get estimatedInstanceWarmup(): number;
    /**
     * @stability stable
     */
    set estimatedInstanceWarmup(value: number);
    /**
     * @stability stable
     */
    resetEstimatedInstanceWarmup(): void;
    /**
     * @stability stable
     */
    get estimatedInstanceWarmupInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricAggregationType?;
    /**
     * @stability stable
     */
    get metricAggregationType(): string;
    /**
     * @stability stable
     */
    set metricAggregationType(value: string);
    /**
     * @stability stable
     */
    resetMetricAggregationType(): void;
    /**
     * @stability stable
     */
    get metricAggregationTypeInput(): string | undefined;
    private _minAdjustmentMagnitude?;
    /**
     * @stability stable
     */
    get minAdjustmentMagnitude(): number;
    /**
     * @stability stable
     */
    set minAdjustmentMagnitude(value: number);
    /**
     * @stability stable
     */
    resetMinAdjustmentMagnitude(): void;
    /**
     * @stability stable
     */
    get minAdjustmentMagnitudeInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _policyType?;
    /**
     * @stability stable
     */
    get policyType(): string;
    /**
     * @stability stable
     */
    set policyType(value: string);
    /**
     * @stability stable
     */
    resetPolicyType(): void;
    /**
     * @stability stable
     */
    get policyTypeInput(): string | undefined;
    private _scalingAdjustment?;
    /**
     * @stability stable
     */
    get scalingAdjustment(): number;
    /**
     * @stability stable
     */
    set scalingAdjustment(value: number);
    /**
     * @stability stable
     */
    resetScalingAdjustment(): void;
    /**
     * @stability stable
     */
    get scalingAdjustmentInput(): number | undefined;
    private _predictiveScalingConfiguration?;
    /**
     * @stability stable
     */
    get predictiveScalingConfiguration(): AutoscalingPolicyPredictiveScalingConfiguration[];
    /**
     * @stability stable
     */
    set predictiveScalingConfiguration(value: AutoscalingPolicyPredictiveScalingConfiguration[]);
    /**
     * @stability stable
     */
    resetPredictiveScalingConfiguration(): void;
    /**
     * @stability stable
     */
    get predictiveScalingConfigurationInput(): AutoscalingPolicyPredictiveScalingConfiguration[] | undefined;
    private _stepAdjustment?;
    /**
     * @stability stable
     */
    get stepAdjustment(): AutoscalingPolicyStepAdjustment[];
    /**
     * @stability stable
     */
    set stepAdjustment(value: AutoscalingPolicyStepAdjustment[]);
    /**
     * @stability stable
     */
    resetStepAdjustment(): void;
    /**
     * @stability stable
     */
    get stepAdjustmentInput(): AutoscalingPolicyStepAdjustment[] | undefined;
    private _targetTrackingConfiguration?;
    /**
     * @stability stable
     */
    get targetTrackingConfiguration(): AutoscalingPolicyTargetTrackingConfiguration[];
    /**
     * @stability stable
     */
    set targetTrackingConfiguration(value: AutoscalingPolicyTargetTrackingConfiguration[]);
    /**
     * @stability stable
     */
    resetTargetTrackingConfiguration(): void;
    /**
     * @stability stable
     */
    get targetTrackingConfigurationInput(): AutoscalingPolicyTargetTrackingConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
