import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEcrRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_repository.html#name DataAwsEcrRepository#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_repository.html#registry_id DataAwsEcrRepository#registry_id}.
     *
     * @stability stable
     */
    readonly registryId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_repository.html#tags DataAwsEcrRepository#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsEcrRepositoryEncryptionConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get encryptionType(): string;
    /**
     * @stability stable
     */
    get kmsKey(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEcrRepositoryImageScanningConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get scanOnPush(): boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ecr_repository.html aws_ecr_repository}.
 *
 * @stability stable
 */
export declare class DataAwsEcrRepository extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ecr_repository.html aws_ecr_repository} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEcrRepositoryConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    encryptionConfiguration(index: string): DataAwsEcrRepositoryEncryptionConfiguration;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    imageScanningConfiguration(index: string): DataAwsEcrRepositoryImageScanningConfiguration;
    /**
     * @stability stable
     */
    get imageTagMutability(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _registryId?;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    set registryId(value: string);
    /**
     * @stability stable
     */
    resetRegistryId(): void;
    /**
     * @stability stable
     */
    get registryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get repositoryUrl(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
