import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsNeptuneEngineVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#engine DataAwsNeptuneEngineVersion#engine}.
     *
     * @stability stable
     */
    readonly engine?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#parameter_group_family DataAwsNeptuneEngineVersion#parameter_group_family}.
     *
     * @stability stable
     */
    readonly parameterGroupFamily?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#preferred_versions DataAwsNeptuneEngineVersion#preferred_versions}.
     *
     * @stability stable
     */
    readonly preferredVersions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#version DataAwsNeptuneEngineVersion#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html aws_neptune_engine_version}.
 *
 * @stability stable
 */
export declare class DataAwsNeptuneEngineVersion extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html aws_neptune_engine_version} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsNeptuneEngineVersionConfig);
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineDescription(): string;
    /**
     * @stability stable
     */
    get exportableLogTypes(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _parameterGroupFamily?;
    /**
     * @stability stable
     */
    get parameterGroupFamily(): string;
    /**
     * @stability stable
     */
    set parameterGroupFamily(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupFamily(): void;
    /**
     * @stability stable
     */
    get parameterGroupFamilyInput(): string | undefined;
    private _preferredVersions?;
    /**
     * @stability stable
     */
    get preferredVersions(): string[];
    /**
     * @stability stable
     */
    set preferredVersions(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredVersions(): void;
    /**
     * @stability stable
     */
    get preferredVersionsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get supportedTimezones(): string[];
    /**
     * @stability stable
     */
    get supportsLogExportsToCloudwatch(): boolean;
    /**
     * @stability stable
     */
    get supportsReadReplica(): boolean;
    /**
     * @stability stable
     */
    get validUpgradeTargets(): string[];
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionDescription(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
