import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayPrefixListReferenceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#blackhole Ec2TransitGatewayPrefixListReference#blackhole}.
     *
     * @stability stable
     */
    readonly blackhole?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#prefix_list_id Ec2TransitGatewayPrefixListReference#prefix_list_id}.
     *
     * @stability stable
     */
    readonly prefixListId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#transit_gateway_attachment_id Ec2TransitGatewayPrefixListReference#transit_gateway_attachment_id}.
     *
     * @stability stable
     */
    readonly transitGatewayAttachmentId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#transit_gateway_route_table_id Ec2TransitGatewayPrefixListReference#transit_gateway_route_table_id}.
     *
     * @stability stable
     */
    readonly transitGatewayRouteTableId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html aws_ec2_transit_gateway_prefix_list_reference}.
 *
 * @stability stable
 */
export declare class Ec2TransitGatewayPrefixListReference extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html aws_ec2_transit_gateway_prefix_list_reference} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayPrefixListReferenceConfig);
    private _blackhole?;
    /**
     * @stability stable
     */
    get blackhole(): boolean;
    /**
     * @stability stable
     */
    set blackhole(value: boolean);
    /**
     * @stability stable
     */
    resetBlackhole(): void;
    /**
     * @stability stable
     */
    get blackholeInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _prefixListId;
    /**
     * @stability stable
     */
    get prefixListId(): string;
    /**
     * @stability stable
     */
    set prefixListId(value: string);
    /**
     * @stability stable
     */
    get prefixListIdInput(): string;
    /**
     * @stability stable
     */
    get prefixListOwnerId(): string;
    private _transitGatewayAttachmentId?;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentId(): string;
    /**
     * @stability stable
     */
    set transitGatewayAttachmentId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayAttachmentId(): void;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentIdInput(): string | undefined;
    private _transitGatewayRouteTableId;
    /**
     * @stability stable
     */
    get transitGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set transitGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayRouteTableIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
