import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EksAddonConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#addon_name EksAddon#addon_name}.
     *
     * @stability stable
     */
    readonly addonName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#addon_version EksAddon#addon_version}.
     *
     * @stability stable
     */
    readonly addonVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#cluster_name EksAddon#cluster_name}.
     *
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#resolve_conflicts EksAddon#resolve_conflicts}.
     *
     * @stability stable
     */
    readonly resolveConflicts?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#service_account_role_arn EksAddon#service_account_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccountRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#tags EksAddon#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html#tags_all EksAddon#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html aws_eks_addon}.
 *
 * @stability stable
 */
export declare class EksAddon extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/eks_addon.html aws_eks_addon} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EksAddonConfig);
    private _addonName;
    /**
     * @stability stable
     */
    get addonName(): string;
    /**
     * @stability stable
     */
    set addonName(value: string);
    /**
     * @stability stable
     */
    get addonNameInput(): string;
    private _addonVersion?;
    /**
     * @stability stable
     */
    get addonVersion(): string;
    /**
     * @stability stable
     */
    set addonVersion(value: string);
    /**
     * @stability stable
     */
    resetAddonVersion(): void;
    /**
     * @stability stable
     */
    get addonVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _clusterName;
    /**
     * @stability stable
     */
    get clusterName(): string;
    /**
     * @stability stable
     */
    set clusterName(value: string);
    /**
     * @stability stable
     */
    get clusterNameInput(): string;
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get modifiedAt(): string;
    private _resolveConflicts?;
    /**
     * @stability stable
     */
    get resolveConflicts(): string;
    /**
     * @stability stable
     */
    set resolveConflicts(value: string);
    /**
     * @stability stable
     */
    resetResolveConflicts(): void;
    /**
     * @stability stable
     */
    get resolveConflictsInput(): string | undefined;
    private _serviceAccountRoleArn?;
    /**
     * @stability stable
     */
    get serviceAccountRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceAccountRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceAccountRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceAccountRoleArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
