import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GameliftFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#build_id GameliftFleet#build_id}.
     *
     * @stability stable
     */
    readonly buildId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#description GameliftFleet#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ec2_instance_type GameliftFleet#ec2_instance_type}.
     *
     * @stability stable
     */
    readonly ec2InstanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#fleet_type GameliftFleet#fleet_type}.
     *
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#instance_role_arn GameliftFleet#instance_role_arn}.
     *
     * @stability stable
     */
    readonly instanceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#metric_groups GameliftFleet#metric_groups}.
     *
     * @stability stable
     */
    readonly metricGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#name GameliftFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#new_game_session_protection_policy GameliftFleet#new_game_session_protection_policy}.
     *
     * @stability stable
     */
    readonly newGameSessionProtectionPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#tags GameliftFleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#tags_all GameliftFleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * ec2_inbound_permission block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ec2_inbound_permission GameliftFleet#ec2_inbound_permission}
     *
     * @stability stable
     */
    readonly ec2InboundPermission?: GameliftFleetEc2InboundPermission[];
    /**
     * resource_creation_limit_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#resource_creation_limit_policy GameliftFleet#resource_creation_limit_policy}
     *
     * @stability stable
     */
    readonly resourceCreationLimitPolicy?: GameliftFleetResourceCreationLimitPolicy[];
    /**
     * runtime_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#runtime_configuration GameliftFleet#runtime_configuration}
     *
     * @stability stable
     */
    readonly runtimeConfiguration?: GameliftFleetRuntimeConfiguration[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#timeouts GameliftFleet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GameliftFleetTimeouts;
}
/**
 * @stability stable
 */
export interface GameliftFleetEc2InboundPermission {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#from_port GameliftFleet#from_port}.
     *
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ip_range GameliftFleet#ip_range}.
     *
     * @stability stable
     */
    readonly ipRange: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#protocol GameliftFleet#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#to_port GameliftFleet#to_port}.
     *
     * @stability stable
     */
    readonly toPort: number;
}
/**
 * @stability stable
 */
export interface GameliftFleetResourceCreationLimitPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#new_game_sessions_per_creator GameliftFleet#new_game_sessions_per_creator}.
     *
     * @stability stable
     */
    readonly newGameSessionsPerCreator?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#policy_period_in_minutes GameliftFleet#policy_period_in_minutes}.
     *
     * @stability stable
     */
    readonly policyPeriodInMinutes?: number;
}
/**
 * @stability stable
 */
export interface GameliftFleetRuntimeConfigurationServerProcess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#concurrent_executions GameliftFleet#concurrent_executions}.
     *
     * @stability stable
     */
    readonly concurrentExecutions: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#launch_path GameliftFleet#launch_path}.
     *
     * @stability stable
     */
    readonly launchPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#parameters GameliftFleet#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: string;
}
/**
 * @stability stable
 */
export interface GameliftFleetRuntimeConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#game_session_activation_timeout_seconds GameliftFleet#game_session_activation_timeout_seconds}.
     *
     * @stability stable
     */
    readonly gameSessionActivationTimeoutSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#max_concurrent_game_session_activations GameliftFleet#max_concurrent_game_session_activations}.
     *
     * @stability stable
     */
    readonly maxConcurrentGameSessionActivations?: number;
    /**
     * server_process block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#server_process GameliftFleet#server_process}
     *
     * @stability stable
     */
    readonly serverProcess?: GameliftFleetRuntimeConfigurationServerProcess[];
}
/**
 * @stability stable
 */
export interface GameliftFleetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#create GameliftFleet#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#delete GameliftFleet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html aws_gamelift_fleet}.
 *
 * @stability stable
 */
export declare class GameliftFleet extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html aws_gamelift_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GameliftFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _buildId;
    /**
     * @stability stable
     */
    get buildId(): string;
    /**
     * @stability stable
     */
    set buildId(value: string);
    /**
     * @stability stable
     */
    get buildIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _ec2InstanceType;
    /**
     * @stability stable
     */
    get ec2InstanceType(): string;
    /**
     * @stability stable
     */
    set ec2InstanceType(value: string);
    /**
     * @stability stable
     */
    get ec2InstanceTypeInput(): string;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceRoleArn?;
    /**
     * @stability stable
     */
    get instanceRoleArn(): string;
    /**
     * @stability stable
     */
    set instanceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetInstanceRoleArn(): void;
    /**
     * @stability stable
     */
    get instanceRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get logPaths(): string[];
    private _metricGroups?;
    /**
     * @stability stable
     */
    get metricGroups(): string[];
    /**
     * @stability stable
     */
    set metricGroups(value: string[]);
    /**
     * @stability stable
     */
    resetMetricGroups(): void;
    /**
     * @stability stable
     */
    get metricGroupsInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _newGameSessionProtectionPolicy?;
    /**
     * @stability stable
     */
    get newGameSessionProtectionPolicy(): string;
    /**
     * @stability stable
     */
    set newGameSessionProtectionPolicy(value: string);
    /**
     * @stability stable
     */
    resetNewGameSessionProtectionPolicy(): void;
    /**
     * @stability stable
     */
    get newGameSessionProtectionPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get operatingSystem(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _ec2InboundPermission?;
    /**
     * @stability stable
     */
    get ec2InboundPermission(): GameliftFleetEc2InboundPermission[];
    /**
     * @stability stable
     */
    set ec2InboundPermission(value: GameliftFleetEc2InboundPermission[]);
    /**
     * @stability stable
     */
    resetEc2InboundPermission(): void;
    /**
     * @stability stable
     */
    get ec2InboundPermissionInput(): GameliftFleetEc2InboundPermission[] | undefined;
    private _resourceCreationLimitPolicy?;
    /**
     * @stability stable
     */
    get resourceCreationLimitPolicy(): GameliftFleetResourceCreationLimitPolicy[];
    /**
     * @stability stable
     */
    set resourceCreationLimitPolicy(value: GameliftFleetResourceCreationLimitPolicy[]);
    /**
     * @stability stable
     */
    resetResourceCreationLimitPolicy(): void;
    /**
     * @stability stable
     */
    get resourceCreationLimitPolicyInput(): GameliftFleetResourceCreationLimitPolicy[] | undefined;
    private _runtimeConfiguration?;
    /**
     * @stability stable
     */
    get runtimeConfiguration(): GameliftFleetRuntimeConfiguration[];
    /**
     * @stability stable
     */
    set runtimeConfiguration(value: GameliftFleetRuntimeConfiguration[]);
    /**
     * @stability stable
     */
    resetRuntimeConfiguration(): void;
    /**
     * @stability stable
     */
    get runtimeConfigurationInput(): GameliftFleetRuntimeConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GameliftFleetTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GameliftFleetTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GameliftFleetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
