import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueCatalogTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#catalog_id GlueCatalogTable#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#database_name GlueCatalogTable#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#description GlueCatalogTable#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#name GlueCatalogTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#owner GlueCatalogTable#owner}.
     *
     * @stability stable
     */
    readonly owner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#parameters GlueCatalogTable#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#retention GlueCatalogTable#retention}.
     *
     * @stability stable
     */
    readonly retention?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#table_type GlueCatalogTable#table_type}.
     *
     * @stability stable
     */
    readonly tableType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#view_expanded_text GlueCatalogTable#view_expanded_text}.
     *
     * @stability stable
     */
    readonly viewExpandedText?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#view_original_text GlueCatalogTable#view_original_text}.
     *
     * @stability stable
     */
    readonly viewOriginalText?: string;
    /**
     * partition_index block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#partition_index GlueCatalogTable#partition_index}
     *
     * @stability stable
     */
    readonly partitionIndex?: GlueCatalogTablePartitionIndex[];
    /**
     * partition_keys block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#partition_keys GlueCatalogTable#partition_keys}
     *
     * @stability stable
     */
    readonly partitionKeys?: GlueCatalogTablePartitionKeys[];
    /**
     * storage_descriptor block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#storage_descriptor GlueCatalogTable#storage_descriptor}
     *
     * @stability stable
     */
    readonly storageDescriptor?: GlueCatalogTableStorageDescriptor[];
    /**
     * target_table block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#target_table GlueCatalogTable#target_table}
     *
     * @stability stable
     */
    readonly targetTable?: GlueCatalogTableTargetTable[];
}
/**
 * @stability stable
 */
export interface GlueCatalogTablePartitionIndex {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#index_name GlueCatalogTable#index_name}.
     *
     * @stability stable
     */
    readonly indexName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#keys GlueCatalogTable#keys}.
     *
     * @stability stable
     */
    readonly keys: string[];
}
/**
 * @stability stable
 */
export interface GlueCatalogTablePartitionKeys {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#comment GlueCatalogTable#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#name GlueCatalogTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#type GlueCatalogTable#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorColumns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#comment GlueCatalogTable#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#name GlueCatalogTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#parameters GlueCatalogTable#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#type GlueCatalogTable#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorSchemaReferenceSchemaId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#registry_name GlueCatalogTable#registry_name}.
     *
     * @stability stable
     */
    readonly registryName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_arn GlueCatalogTable#schema_arn}.
     *
     * @stability stable
     */
    readonly schemaArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_name GlueCatalogTable#schema_name}.
     *
     * @stability stable
     */
    readonly schemaName?: string;
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorSchemaReference {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_version_id GlueCatalogTable#schema_version_id}.
     *
     * @stability stable
     */
    readonly schemaVersionId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_version_number GlueCatalogTable#schema_version_number}.
     *
     * @stability stable
     */
    readonly schemaVersionNumber: number;
    /**
     * schema_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_id GlueCatalogTable#schema_id}
     *
     * @stability stable
     */
    readonly schemaId?: GlueCatalogTableStorageDescriptorSchemaReferenceSchemaId[];
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorSerDeInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#name GlueCatalogTable#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#parameters GlueCatalogTable#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#serialization_library GlueCatalogTable#serialization_library}.
     *
     * @stability stable
     */
    readonly serializationLibrary?: string;
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorSkewedInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#skewed_column_names GlueCatalogTable#skewed_column_names}.
     *
     * @stability stable
     */
    readonly skewedColumnNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#skewed_column_value_location_maps GlueCatalogTable#skewed_column_value_location_maps}.
     *
     * @stability stable
     */
    readonly skewedColumnValueLocationMaps?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#skewed_column_values GlueCatalogTable#skewed_column_values}.
     *
     * @stability stable
     */
    readonly skewedColumnValues?: string[];
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptorSortColumns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#column GlueCatalogTable#column}.
     *
     * @stability stable
     */
    readonly column: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#sort_order GlueCatalogTable#sort_order}.
     *
     * @stability stable
     */
    readonly sortOrder: number;
}
/**
 * @stability stable
 */
export interface GlueCatalogTableStorageDescriptor {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#bucket_columns GlueCatalogTable#bucket_columns}.
     *
     * @stability stable
     */
    readonly bucketColumns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#compressed GlueCatalogTable#compressed}.
     *
     * @stability stable
     */
    readonly compressed?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#input_format GlueCatalogTable#input_format}.
     *
     * @stability stable
     */
    readonly inputFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#location GlueCatalogTable#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#number_of_buckets GlueCatalogTable#number_of_buckets}.
     *
     * @stability stable
     */
    readonly numberOfBuckets?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#output_format GlueCatalogTable#output_format}.
     *
     * @stability stable
     */
    readonly outputFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#parameters GlueCatalogTable#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#stored_as_sub_directories GlueCatalogTable#stored_as_sub_directories}.
     *
     * @stability stable
     */
    readonly storedAsSubDirectories?: boolean;
    /**
     * columns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#columns GlueCatalogTable#columns}
     *
     * @stability stable
     */
    readonly columns?: GlueCatalogTableStorageDescriptorColumns[];
    /**
     * schema_reference block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#schema_reference GlueCatalogTable#schema_reference}
     *
     * @stability stable
     */
    readonly schemaReference?: GlueCatalogTableStorageDescriptorSchemaReference[];
    /**
     * ser_de_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#ser_de_info GlueCatalogTable#ser_de_info}
     *
     * @stability stable
     */
    readonly serDeInfo?: GlueCatalogTableStorageDescriptorSerDeInfo[];
    /**
     * skewed_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#skewed_info GlueCatalogTable#skewed_info}
     *
     * @stability stable
     */
    readonly skewedInfo?: GlueCatalogTableStorageDescriptorSkewedInfo[];
    /**
     * sort_columns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#sort_columns GlueCatalogTable#sort_columns}
     *
     * @stability stable
     */
    readonly sortColumns?: GlueCatalogTableStorageDescriptorSortColumns[];
}
/**
 * @stability stable
 */
export interface GlueCatalogTableTargetTable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#catalog_id GlueCatalogTable#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#database_name GlueCatalogTable#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html#name GlueCatalogTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html aws_glue_catalog_table}.
 *
 * @stability stable
 */
export declare class GlueCatalogTable extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_catalog_table.html aws_glue_catalog_table} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueCatalogTableConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _owner?;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    set owner(value: string);
    /**
     * @stability stable
     */
    resetOwner(): void;
    /**
     * @stability stable
     */
    get ownerInput(): string | undefined;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _retention?;
    /**
     * @stability stable
     */
    get retention(): number;
    /**
     * @stability stable
     */
    set retention(value: number);
    /**
     * @stability stable
     */
    resetRetention(): void;
    /**
     * @stability stable
     */
    get retentionInput(): number | undefined;
    private _tableType?;
    /**
     * @stability stable
     */
    get tableType(): string;
    /**
     * @stability stable
     */
    set tableType(value: string);
    /**
     * @stability stable
     */
    resetTableType(): void;
    /**
     * @stability stable
     */
    get tableTypeInput(): string | undefined;
    private _viewExpandedText?;
    /**
     * @stability stable
     */
    get viewExpandedText(): string;
    /**
     * @stability stable
     */
    set viewExpandedText(value: string);
    /**
     * @stability stable
     */
    resetViewExpandedText(): void;
    /**
     * @stability stable
     */
    get viewExpandedTextInput(): string | undefined;
    private _viewOriginalText?;
    /**
     * @stability stable
     */
    get viewOriginalText(): string;
    /**
     * @stability stable
     */
    set viewOriginalText(value: string);
    /**
     * @stability stable
     */
    resetViewOriginalText(): void;
    /**
     * @stability stable
     */
    get viewOriginalTextInput(): string | undefined;
    private _partitionIndex?;
    /**
     * @stability stable
     */
    get partitionIndex(): GlueCatalogTablePartitionIndex[];
    /**
     * @stability stable
     */
    set partitionIndex(value: GlueCatalogTablePartitionIndex[]);
    /**
     * @stability stable
     */
    resetPartitionIndex(): void;
    /**
     * @stability stable
     */
    get partitionIndexInput(): GlueCatalogTablePartitionIndex[] | undefined;
    private _partitionKeys?;
    /**
     * @stability stable
     */
    get partitionKeys(): GlueCatalogTablePartitionKeys[];
    /**
     * @stability stable
     */
    set partitionKeys(value: GlueCatalogTablePartitionKeys[]);
    /**
     * @stability stable
     */
    resetPartitionKeys(): void;
    /**
     * @stability stable
     */
    get partitionKeysInput(): GlueCatalogTablePartitionKeys[] | undefined;
    private _storageDescriptor?;
    /**
     * @stability stable
     */
    get storageDescriptor(): GlueCatalogTableStorageDescriptor[];
    /**
     * @stability stable
     */
    set storageDescriptor(value: GlueCatalogTableStorageDescriptor[]);
    /**
     * @stability stable
     */
    resetStorageDescriptor(): void;
    /**
     * @stability stable
     */
    get storageDescriptorInput(): GlueCatalogTableStorageDescriptor[] | undefined;
    private _targetTable?;
    /**
     * @stability stable
     */
    get targetTable(): GlueCatalogTableTargetTable[];
    /**
     * @stability stable
     */
    set targetTable(value: GlueCatalogTableTargetTable[]);
    /**
     * @stability stable
     */
    resetTargetTable(): void;
    /**
     * @stability stable
     */
    get targetTableInput(): GlueCatalogTableTargetTable[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
