import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueCrawlerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#classifiers GlueCrawler#classifiers}.
     *
     * @stability stable
     */
    readonly classifiers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#configuration GlueCrawler#configuration}.
     *
     * @stability stable
     */
    readonly configuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#database_name GlueCrawler#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#description GlueCrawler#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#name GlueCrawler#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#role GlueCrawler#role}.
     *
     * @stability stable
     */
    readonly role: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#schedule GlueCrawler#schedule}.
     *
     * @stability stable
     */
    readonly schedule?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#security_configuration GlueCrawler#security_configuration}.
     *
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#table_prefix GlueCrawler#table_prefix}.
     *
     * @stability stable
     */
    readonly tablePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#tags GlueCrawler#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#tags_all GlueCrawler#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * catalog_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#catalog_target GlueCrawler#catalog_target}
     *
     * @stability stable
     */
    readonly catalogTarget?: GlueCrawlerCatalogTarget[];
    /**
     * dynamodb_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#dynamodb_target GlueCrawler#dynamodb_target}
     *
     * @stability stable
     */
    readonly dynamodbTarget?: GlueCrawlerDynamodbTarget[];
    /**
     * jdbc_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#jdbc_target GlueCrawler#jdbc_target}
     *
     * @stability stable
     */
    readonly jdbcTarget?: GlueCrawlerJdbcTarget[];
    /**
     * lineage_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#lineage_configuration GlueCrawler#lineage_configuration}
     *
     * @stability stable
     */
    readonly lineageConfiguration?: GlueCrawlerLineageConfiguration[];
    /**
     * mongodb_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#mongodb_target GlueCrawler#mongodb_target}
     *
     * @stability stable
     */
    readonly mongodbTarget?: GlueCrawlerMongodbTarget[];
    /**
     * recrawl_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#recrawl_policy GlueCrawler#recrawl_policy}
     *
     * @stability stable
     */
    readonly recrawlPolicy?: GlueCrawlerRecrawlPolicy[];
    /**
     * s3_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#s3_target GlueCrawler#s3_target}
     *
     * @stability stable
     */
    readonly s3Target?: GlueCrawlerS3Target[];
    /**
     * schema_change_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#schema_change_policy GlueCrawler#schema_change_policy}
     *
     * @stability stable
     */
    readonly schemaChangePolicy?: GlueCrawlerSchemaChangePolicy[];
}
/**
 * @stability stable
 */
export interface GlueCrawlerCatalogTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#database_name GlueCrawler#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#tables GlueCrawler#tables}.
     *
     * @stability stable
     */
    readonly tables: string[];
}
/**
 * @stability stable
 */
export interface GlueCrawlerDynamodbTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#scan_all GlueCrawler#scan_all}.
     *
     * @stability stable
     */
    readonly scanAll?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#scan_rate GlueCrawler#scan_rate}.
     *
     * @stability stable
     */
    readonly scanRate?: number;
}
/**
 * @stability stable
 */
export interface GlueCrawlerJdbcTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#exclusions GlueCrawler#exclusions}.
     *
     * @stability stable
     */
    readonly exclusions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface GlueCrawlerLineageConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#crawler_lineage_settings GlueCrawler#crawler_lineage_settings}.
     *
     * @stability stable
     */
    readonly crawlerLineageSettings?: string;
}
/**
 * @stability stable
 */
export interface GlueCrawlerMongodbTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#scan_all GlueCrawler#scan_all}.
     *
     * @stability stable
     */
    readonly scanAll?: boolean;
}
/**
 * @stability stable
 */
export interface GlueCrawlerRecrawlPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#recrawl_behavior GlueCrawler#recrawl_behavior}.
     *
     * @stability stable
     */
    readonly recrawlBehavior?: string;
}
/**
 * @stability stable
 */
export interface GlueCrawlerS3Target {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#exclusions GlueCrawler#exclusions}.
     *
     * @stability stable
     */
    readonly exclusions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface GlueCrawlerSchemaChangePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#delete_behavior GlueCrawler#delete_behavior}.
     *
     * @stability stable
     */
    readonly deleteBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html#update_behavior GlueCrawler#update_behavior}.
     *
     * @stability stable
     */
    readonly updateBehavior?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html aws_glue_crawler}.
 *
 * @stability stable
 */
export declare class GlueCrawler extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler.html aws_glue_crawler} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueCrawlerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _classifiers?;
    /**
     * @stability stable
     */
    get classifiers(): string[];
    /**
     * @stability stable
     */
    set classifiers(value: string[]);
    /**
     * @stability stable
     */
    resetClassifiers(): void;
    /**
     * @stability stable
     */
    get classifiersInput(): string[] | undefined;
    private _configuration?;
    /**
     * @stability stable
     */
    get configuration(): string;
    /**
     * @stability stable
     */
    set configuration(value: string);
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): string | undefined;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _role;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    set role(value: string);
    /**
     * @stability stable
     */
    get roleInput(): string;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): string | undefined;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _tablePrefix?;
    /**
     * @stability stable
     */
    get tablePrefix(): string;
    /**
     * @stability stable
     */
    set tablePrefix(value: string);
    /**
     * @stability stable
     */
    resetTablePrefix(): void;
    /**
     * @stability stable
     */
    get tablePrefixInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _catalogTarget?;
    /**
     * @stability stable
     */
    get catalogTarget(): GlueCrawlerCatalogTarget[];
    /**
     * @stability stable
     */
    set catalogTarget(value: GlueCrawlerCatalogTarget[]);
    /**
     * @stability stable
     */
    resetCatalogTarget(): void;
    /**
     * @stability stable
     */
    get catalogTargetInput(): GlueCrawlerCatalogTarget[] | undefined;
    private _dynamodbTarget?;
    /**
     * @stability stable
     */
    get dynamodbTarget(): GlueCrawlerDynamodbTarget[];
    /**
     * @stability stable
     */
    set dynamodbTarget(value: GlueCrawlerDynamodbTarget[]);
    /**
     * @stability stable
     */
    resetDynamodbTarget(): void;
    /**
     * @stability stable
     */
    get dynamodbTargetInput(): GlueCrawlerDynamodbTarget[] | undefined;
    private _jdbcTarget?;
    /**
     * @stability stable
     */
    get jdbcTarget(): GlueCrawlerJdbcTarget[];
    /**
     * @stability stable
     */
    set jdbcTarget(value: GlueCrawlerJdbcTarget[]);
    /**
     * @stability stable
     */
    resetJdbcTarget(): void;
    /**
     * @stability stable
     */
    get jdbcTargetInput(): GlueCrawlerJdbcTarget[] | undefined;
    private _lineageConfiguration?;
    /**
     * @stability stable
     */
    get lineageConfiguration(): GlueCrawlerLineageConfiguration[];
    /**
     * @stability stable
     */
    set lineageConfiguration(value: GlueCrawlerLineageConfiguration[]);
    /**
     * @stability stable
     */
    resetLineageConfiguration(): void;
    /**
     * @stability stable
     */
    get lineageConfigurationInput(): GlueCrawlerLineageConfiguration[] | undefined;
    private _mongodbTarget?;
    /**
     * @stability stable
     */
    get mongodbTarget(): GlueCrawlerMongodbTarget[];
    /**
     * @stability stable
     */
    set mongodbTarget(value: GlueCrawlerMongodbTarget[]);
    /**
     * @stability stable
     */
    resetMongodbTarget(): void;
    /**
     * @stability stable
     */
    get mongodbTargetInput(): GlueCrawlerMongodbTarget[] | undefined;
    private _recrawlPolicy?;
    /**
     * @stability stable
     */
    get recrawlPolicy(): GlueCrawlerRecrawlPolicy[];
    /**
     * @stability stable
     */
    set recrawlPolicy(value: GlueCrawlerRecrawlPolicy[]);
    /**
     * @stability stable
     */
    resetRecrawlPolicy(): void;
    /**
     * @stability stable
     */
    get recrawlPolicyInput(): GlueCrawlerRecrawlPolicy[] | undefined;
    private _s3Target?;
    /**
     * @stability stable
     */
    get s3Target(): GlueCrawlerS3Target[];
    /**
     * @stability stable
     */
    set s3Target(value: GlueCrawlerS3Target[]);
    /**
     * @stability stable
     */
    resetS3Target(): void;
    /**
     * @stability stable
     */
    get s3TargetInput(): GlueCrawlerS3Target[] | undefined;
    private _schemaChangePolicy?;
    /**
     * @stability stable
     */
    get schemaChangePolicy(): GlueCrawlerSchemaChangePolicy[];
    /**
     * @stability stable
     */
    set schemaChangePolicy(value: GlueCrawlerSchemaChangePolicy[]);
    /**
     * @stability stable
     */
    resetSchemaChangePolicy(): void;
    /**
     * @stability stable
     */
    get schemaChangePolicyInput(): GlueCrawlerSchemaChangePolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
