import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#description ImagebuilderImagePipeline#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#distribution_configuration_arn ImagebuilderImagePipeline#distribution_configuration_arn}.
     *
     * @stability stable
     */
    readonly distributionConfigurationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#enhanced_image_metadata_enabled ImagebuilderImagePipeline#enhanced_image_metadata_enabled}.
     *
     * @stability stable
     */
    readonly enhancedImageMetadataEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_recipe_arn ImagebuilderImagePipeline#image_recipe_arn}.
     *
     * @stability stable
     */
    readonly imageRecipeArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#infrastructure_configuration_arn ImagebuilderImagePipeline#infrastructure_configuration_arn}.
     *
     * @stability stable
     */
    readonly infrastructureConfigurationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#name ImagebuilderImagePipeline#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#status ImagebuilderImagePipeline#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#tags ImagebuilderImagePipeline#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#tags_all ImagebuilderImagePipeline#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * image_tests_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_tests_configuration ImagebuilderImagePipeline#image_tests_configuration}
     *
     * @stability stable
     */
    readonly imageTestsConfiguration?: ImagebuilderImagePipelineImageTestsConfiguration[];
    /**
     * schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#schedule ImagebuilderImagePipeline#schedule}
     *
     * @stability stable
     */
    readonly schedule?: ImagebuilderImagePipelineSchedule[];
}
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineImageTestsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_tests_enabled ImagebuilderImagePipeline#image_tests_enabled}.
     *
     * @stability stable
     */
    readonly imageTestsEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#timeout_minutes ImagebuilderImagePipeline#timeout_minutes}.
     *
     * @stability stable
     */
    readonly timeoutMinutes?: number;
}
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineSchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#pipeline_execution_start_condition ImagebuilderImagePipeline#pipeline_execution_start_condition}.
     *
     * @stability stable
     */
    readonly pipelineExecutionStartCondition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#schedule_expression ImagebuilderImagePipeline#schedule_expression}.
     *
     * @stability stable
     */
    readonly scheduleExpression: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline}.
 *
 * @stability stable
 */
export declare class ImagebuilderImagePipeline extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ImagebuilderImagePipelineConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateLastRun(): string;
    /**
     * @stability stable
     */
    get dateNextRun(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _distributionConfigurationArn?;
    /**
     * @stability stable
     */
    get distributionConfigurationArn(): string;
    /**
     * @stability stable
     */
    set distributionConfigurationArn(value: string);
    /**
     * @stability stable
     */
    resetDistributionConfigurationArn(): void;
    /**
     * @stability stable
     */
    get distributionConfigurationArnInput(): string | undefined;
    private _enhancedImageMetadataEnabled?;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabled(): boolean;
    /**
     * @stability stable
     */
    set enhancedImageMetadataEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnhancedImageMetadataEnabled(): void;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageRecipeArn;
    /**
     * @stability stable
     */
    get imageRecipeArn(): string;
    /**
     * @stability stable
     */
    set imageRecipeArn(value: string);
    /**
     * @stability stable
     */
    get imageRecipeArnInput(): string;
    private _infrastructureConfigurationArn;
    /**
     * @stability stable
     */
    get infrastructureConfigurationArn(): string;
    /**
     * @stability stable
     */
    set infrastructureConfigurationArn(value: string);
    /**
     * @stability stable
     */
    get infrastructureConfigurationArnInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _imageTestsConfiguration?;
    /**
     * @stability stable
     */
    get imageTestsConfiguration(): ImagebuilderImagePipelineImageTestsConfiguration[];
    /**
     * @stability stable
     */
    set imageTestsConfiguration(value: ImagebuilderImagePipelineImageTestsConfiguration[]);
    /**
     * @stability stable
     */
    resetImageTestsConfiguration(): void;
    /**
     * @stability stable
     */
    get imageTestsConfigurationInput(): ImagebuilderImagePipelineImageTestsConfiguration[] | undefined;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): ImagebuilderImagePipelineSchedule[];
    /**
     * @stability stable
     */
    set schedule(value: ImagebuilderImagePipelineSchedule[]);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): ImagebuilderImagePipelineSchedule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
