import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexIntentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#create_version LexIntent#create_version}.
     *
     * @stability stable
     */
    readonly createVersion?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#description LexIntent#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#name LexIntent#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#parent_intent_signature LexIntent#parent_intent_signature}.
     *
     * @stability stable
     */
    readonly parentIntentSignature?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#sample_utterances LexIntent#sample_utterances}.
     *
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * conclusion_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#conclusion_statement LexIntent#conclusion_statement}
     *
     * @stability stable
     */
    readonly conclusionStatement?: LexIntentConclusionStatement[];
    /**
     * confirmation_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#confirmation_prompt LexIntent#confirmation_prompt}
     *
     * @stability stable
     */
    readonly confirmationPrompt?: LexIntentConfirmationPrompt[];
    /**
     * dialog_code_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#dialog_code_hook LexIntent#dialog_code_hook}
     *
     * @stability stable
     */
    readonly dialogCodeHook?: LexIntentDialogCodeHook[];
    /**
     * follow_up_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#follow_up_prompt LexIntent#follow_up_prompt}
     *
     * @stability stable
     */
    readonly followUpPrompt?: LexIntentFollowUpPrompt[];
    /**
     * fulfillment_activity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#fulfillment_activity LexIntent#fulfillment_activity}
     *
     * @stability stable
     */
    readonly fulfillmentActivity: LexIntentFulfillmentActivity[];
    /**
     * rejection_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#rejection_statement LexIntent#rejection_statement}
     *
     * @stability stable
     */
    readonly rejectionStatement?: LexIntentRejectionStatement[];
    /**
     * slot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot LexIntent#slot}
     *
     * @stability stable
     */
    readonly slot?: LexIntentSlot[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#timeouts LexIntent#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: LexIntentTimeouts;
}
/**
 * @stability stable
 */
export interface LexIntentConclusionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentConclusionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentConclusionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentConfirmationPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentConfirmationPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentConfirmationPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentDialogCodeHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message_version LexIntent#message_version}.
     *
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#uri LexIntent#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptRejectionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPrompt {
    /**
     * prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#prompt LexIntent#prompt}
     *
     * @stability stable
     */
    readonly prompt: LexIntentFollowUpPromptPrompt[];
    /**
     * rejection_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#rejection_statement LexIntent#rejection_statement}
     *
     * @stability stable
     */
    readonly rejectionStatement: LexIntentFollowUpPromptRejectionStatement[];
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivityCodeHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message_version LexIntent#message_version}.
     *
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#uri LexIntent#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#type LexIntent#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * code_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#code_hook LexIntent#code_hook}
     *
     * @stability stable
     */
    readonly codeHook?: LexIntentFulfillmentActivityCodeHook[];
}
/**
 * @stability stable
 */
export interface LexIntentRejectionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentRejectionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentRejectionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentSlotValueElicitationPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentSlot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#description LexIntent#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#name LexIntent#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#priority LexIntent#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#sample_utterances LexIntent#sample_utterances}.
     *
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_constraint LexIntent#slot_constraint}.
     *
     * @stability stable
     */
    readonly slotConstraint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_type LexIntent#slot_type}.
     *
     * @stability stable
     */
    readonly slotType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_type_version LexIntent#slot_type_version}.
     *
     * @stability stable
     */
    readonly slotTypeVersion?: string;
    /**
     * value_elicitation_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#value_elicitation_prompt LexIntent#value_elicitation_prompt}
     *
     * @stability stable
     */
    readonly valueElicitationPrompt?: LexIntentSlotValueElicitationPrompt[];
}
/**
 * @stability stable
 */
export interface LexIntentTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#create LexIntent#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#delete LexIntent#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#update LexIntent#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html aws_lex_intent}.
 *
 * @stability stable
 */
export declare class LexIntent extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html aws_lex_intent} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexIntentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean;
    /**
     * @stability stable
     */
    set createVersion(value: boolean);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parentIntentSignature?;
    /**
     * @stability stable
     */
    get parentIntentSignature(): string;
    /**
     * @stability stable
     */
    set parentIntentSignature(value: string);
    /**
     * @stability stable
     */
    resetParentIntentSignature(): void;
    /**
     * @stability stable
     */
    get parentIntentSignatureInput(): string | undefined;
    private _sampleUtterances?;
    /**
     * @stability stable
     */
    get sampleUtterances(): string[];
    /**
     * @stability stable
     */
    set sampleUtterances(value: string[]);
    /**
     * @stability stable
     */
    resetSampleUtterances(): void;
    /**
     * @stability stable
     */
    get sampleUtterancesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _conclusionStatement?;
    /**
     * @stability stable
     */
    get conclusionStatement(): LexIntentConclusionStatement[];
    /**
     * @stability stable
     */
    set conclusionStatement(value: LexIntentConclusionStatement[]);
    /**
     * @stability stable
     */
    resetConclusionStatement(): void;
    /**
     * @stability stable
     */
    get conclusionStatementInput(): LexIntentConclusionStatement[] | undefined;
    private _confirmationPrompt?;
    /**
     * @stability stable
     */
    get confirmationPrompt(): LexIntentConfirmationPrompt[];
    /**
     * @stability stable
     */
    set confirmationPrompt(value: LexIntentConfirmationPrompt[]);
    /**
     * @stability stable
     */
    resetConfirmationPrompt(): void;
    /**
     * @stability stable
     */
    get confirmationPromptInput(): LexIntentConfirmationPrompt[] | undefined;
    private _dialogCodeHook?;
    /**
     * @stability stable
     */
    get dialogCodeHook(): LexIntentDialogCodeHook[];
    /**
     * @stability stable
     */
    set dialogCodeHook(value: LexIntentDialogCodeHook[]);
    /**
     * @stability stable
     */
    resetDialogCodeHook(): void;
    /**
     * @stability stable
     */
    get dialogCodeHookInput(): LexIntentDialogCodeHook[] | undefined;
    private _followUpPrompt?;
    /**
     * @stability stable
     */
    get followUpPrompt(): LexIntentFollowUpPrompt[];
    /**
     * @stability stable
     */
    set followUpPrompt(value: LexIntentFollowUpPrompt[]);
    /**
     * @stability stable
     */
    resetFollowUpPrompt(): void;
    /**
     * @stability stable
     */
    get followUpPromptInput(): LexIntentFollowUpPrompt[] | undefined;
    private _fulfillmentActivity;
    /**
     * @stability stable
     */
    get fulfillmentActivity(): LexIntentFulfillmentActivity[];
    /**
     * @stability stable
     */
    set fulfillmentActivity(value: LexIntentFulfillmentActivity[]);
    /**
     * @stability stable
     */
    get fulfillmentActivityInput(): LexIntentFulfillmentActivity[];
    private _rejectionStatement?;
    /**
     * @stability stable
     */
    get rejectionStatement(): LexIntentRejectionStatement[];
    /**
     * @stability stable
     */
    set rejectionStatement(value: LexIntentRejectionStatement[]);
    /**
     * @stability stable
     */
    resetRejectionStatement(): void;
    /**
     * @stability stable
     */
    get rejectionStatementInput(): LexIntentRejectionStatement[] | undefined;
    private _slot?;
    /**
     * @stability stable
     */
    get slot(): LexIntentSlot[];
    /**
     * @stability stable
     */
    set slot(value: LexIntentSlot[]);
    /**
     * @stability stable
     */
    resetSlot(): void;
    /**
     * @stability stable
     */
    get slotInput(): LexIntentSlot[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexIntentTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexIntentTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexIntentTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
