import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RedshiftClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#allow_version_upgrade RedshiftCluster#allow_version_upgrade}.
     *
     * @stability stable
     */
    readonly allowVersionUpgrade?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#automated_snapshot_retention_period RedshiftCluster#automated_snapshot_retention_period}.
     *
     * @stability stable
     */
    readonly automatedSnapshotRetentionPeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#availability_zone RedshiftCluster#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_identifier RedshiftCluster#cluster_identifier}.
     *
     * @stability stable
     */
    readonly clusterIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_parameter_group_name RedshiftCluster#cluster_parameter_group_name}.
     *
     * @stability stable
     */
    readonly clusterParameterGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_public_key RedshiftCluster#cluster_public_key}.
     *
     * @stability stable
     */
    readonly clusterPublicKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_revision_number RedshiftCluster#cluster_revision_number}.
     *
     * @stability stable
     */
    readonly clusterRevisionNumber?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_security_groups RedshiftCluster#cluster_security_groups}.
     *
     * @stability stable
     */
    readonly clusterSecurityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_subnet_group_name RedshiftCluster#cluster_subnet_group_name}.
     *
     * @stability stable
     */
    readonly clusterSubnetGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_type RedshiftCluster#cluster_type}.
     *
     * @stability stable
     */
    readonly clusterType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_version RedshiftCluster#cluster_version}.
     *
     * @stability stable
     */
    readonly clusterVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#database_name RedshiftCluster#database_name}.
     *
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#elastic_ip RedshiftCluster#elastic_ip}.
     *
     * @stability stable
     */
    readonly elasticIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#encrypted RedshiftCluster#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#endpoint RedshiftCluster#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#enhanced_vpc_routing RedshiftCluster#enhanced_vpc_routing}.
     *
     * @stability stable
     */
    readonly enhancedVpcRouting?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#final_snapshot_identifier RedshiftCluster#final_snapshot_identifier}.
     *
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#iam_roles RedshiftCluster#iam_roles}.
     *
     * @stability stable
     */
    readonly iamRoles?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#kms_key_id RedshiftCluster#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#master_password RedshiftCluster#master_password}.
     *
     * @stability stable
     */
    readonly masterPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#master_username RedshiftCluster#master_username}.
     *
     * @stability stable
     */
    readonly masterUsername?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#node_type RedshiftCluster#node_type}.
     *
     * @stability stable
     */
    readonly nodeType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#number_of_nodes RedshiftCluster#number_of_nodes}.
     *
     * @stability stable
     */
    readonly numberOfNodes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#owner_account RedshiftCluster#owner_account}.
     *
     * @stability stable
     */
    readonly ownerAccount?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#port RedshiftCluster#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#preferred_maintenance_window RedshiftCluster#preferred_maintenance_window}.
     *
     * @stability stable
     */
    readonly preferredMaintenanceWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#publicly_accessible RedshiftCluster#publicly_accessible}.
     *
     * @stability stable
     */
    readonly publiclyAccessible?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#skip_final_snapshot RedshiftCluster#skip_final_snapshot}.
     *
     * @stability stable
     */
    readonly skipFinalSnapshot?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_cluster_identifier RedshiftCluster#snapshot_cluster_identifier}.
     *
     * @stability stable
     */
    readonly snapshotClusterIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_identifier RedshiftCluster#snapshot_identifier}.
     *
     * @stability stable
     */
    readonly snapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#tags RedshiftCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#tags_all RedshiftCluster#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#vpc_security_group_ids RedshiftCluster#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * logging block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#logging RedshiftCluster#logging}
     *
     * @stability stable
     */
    readonly logging?: RedshiftClusterLogging[];
    /**
     * snapshot_copy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_copy RedshiftCluster#snapshot_copy}
     *
     * @stability stable
     */
    readonly snapshotCopy?: RedshiftClusterSnapshotCopy[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#timeouts RedshiftCluster#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: RedshiftClusterTimeouts;
}
/**
 * @stability stable
 */
export interface RedshiftClusterLogging {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#bucket_name RedshiftCluster#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#enable RedshiftCluster#enable}.
     *
     * @stability stable
     */
    readonly enable: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#s3_key_prefix RedshiftCluster#s3_key_prefix}.
     *
     * @stability stable
     */
    readonly s3KeyPrefix?: string;
}
/**
 * @stability stable
 */
export interface RedshiftClusterSnapshotCopy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#destination_region RedshiftCluster#destination_region}.
     *
     * @stability stable
     */
    readonly destinationRegion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#grant_name RedshiftCluster#grant_name}.
     *
     * @stability stable
     */
    readonly grantName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#retention_period RedshiftCluster#retention_period}.
     *
     * @stability stable
     */
    readonly retentionPeriod?: number;
}
/**
 * @stability stable
 */
export interface RedshiftClusterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#create RedshiftCluster#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#delete RedshiftCluster#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#update RedshiftCluster#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html aws_redshift_cluster}.
 *
 * @stability stable
 */
export declare class RedshiftCluster extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html aws_redshift_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RedshiftClusterConfig);
    private _allowVersionUpgrade?;
    /**
     * @stability stable
     */
    get allowVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set allowVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAllowVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get allowVersionUpgradeInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _automatedSnapshotRetentionPeriod?;
    /**
     * @stability stable
     */
    get automatedSnapshotRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set automatedSnapshotRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetAutomatedSnapshotRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get automatedSnapshotRetentionPeriodInput(): number | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _clusterIdentifier;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string;
    private _clusterParameterGroupName?;
    /**
     * @stability stable
     */
    get clusterParameterGroupName(): string;
    /**
     * @stability stable
     */
    set clusterParameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetClusterParameterGroupName(): void;
    /**
     * @stability stable
     */
    get clusterParameterGroupNameInput(): string | undefined;
    private _clusterPublicKey?;
    /**
     * @stability stable
     */
    get clusterPublicKey(): string;
    /**
     * @stability stable
     */
    set clusterPublicKey(value: string);
    /**
     * @stability stable
     */
    resetClusterPublicKey(): void;
    /**
     * @stability stable
     */
    get clusterPublicKeyInput(): string | undefined;
    private _clusterRevisionNumber?;
    /**
     * @stability stable
     */
    get clusterRevisionNumber(): string;
    /**
     * @stability stable
     */
    set clusterRevisionNumber(value: string);
    /**
     * @stability stable
     */
    resetClusterRevisionNumber(): void;
    /**
     * @stability stable
     */
    get clusterRevisionNumberInput(): string | undefined;
    private _clusterSecurityGroups?;
    /**
     * @stability stable
     */
    get clusterSecurityGroups(): string[];
    /**
     * @stability stable
     */
    set clusterSecurityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetClusterSecurityGroups(): void;
    /**
     * @stability stable
     */
    get clusterSecurityGroupsInput(): string[] | undefined;
    private _clusterSubnetGroupName?;
    /**
     * @stability stable
     */
    get clusterSubnetGroupName(): string;
    /**
     * @stability stable
     */
    set clusterSubnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetClusterSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get clusterSubnetGroupNameInput(): string | undefined;
    private _clusterType?;
    /**
     * @stability stable
     */
    get clusterType(): string;
    /**
     * @stability stable
     */
    set clusterType(value: string);
    /**
     * @stability stable
     */
    resetClusterType(): void;
    /**
     * @stability stable
     */
    get clusterTypeInput(): string | undefined;
    private _clusterVersion?;
    /**
     * @stability stable
     */
    get clusterVersion(): string;
    /**
     * @stability stable
     */
    set clusterVersion(value: string);
    /**
     * @stability stable
     */
    resetClusterVersion(): void;
    /**
     * @stability stable
     */
    get clusterVersionInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _elasticIp?;
    /**
     * @stability stable
     */
    get elasticIp(): string;
    /**
     * @stability stable
     */
    set elasticIp(value: string);
    /**
     * @stability stable
     */
    resetElasticIp(): void;
    /**
     * @stability stable
     */
    get elasticIpInput(): string | undefined;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    set encrypted(value: boolean);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | undefined;
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    resetEndpoint(): void;
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _enhancedVpcRouting?;
    /**
     * @stability stable
     */
    get enhancedVpcRouting(): boolean;
    /**
     * @stability stable
     */
    set enhancedVpcRouting(value: boolean);
    /**
     * @stability stable
     */
    resetEnhancedVpcRouting(): void;
    /**
     * @stability stable
     */
    get enhancedVpcRoutingInput(): boolean | undefined;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    private _iamRoles?;
    /**
     * @stability stable
     */
    get iamRoles(): string[];
    /**
     * @stability stable
     */
    set iamRoles(value: string[]);
    /**
     * @stability stable
     */
    resetIamRoles(): void;
    /**
     * @stability stable
     */
    get iamRolesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _masterPassword?;
    /**
     * @stability stable
     */
    get masterPassword(): string;
    /**
     * @stability stable
     */
    set masterPassword(value: string);
    /**
     * @stability stable
     */
    resetMasterPassword(): void;
    /**
     * @stability stable
     */
    get masterPasswordInput(): string | undefined;
    private _masterUsername?;
    /**
     * @stability stable
     */
    get masterUsername(): string;
    /**
     * @stability stable
     */
    set masterUsername(value: string);
    /**
     * @stability stable
     */
    resetMasterUsername(): void;
    /**
     * @stability stable
     */
    get masterUsernameInput(): string | undefined;
    private _nodeType;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    set nodeType(value: string);
    /**
     * @stability stable
     */
    get nodeTypeInput(): string;
    private _numberOfNodes?;
    /**
     * @stability stable
     */
    get numberOfNodes(): number;
    /**
     * @stability stable
     */
    set numberOfNodes(value: number);
    /**
     * @stability stable
     */
    resetNumberOfNodes(): void;
    /**
     * @stability stable
     */
    get numberOfNodesInput(): number | undefined;
    private _ownerAccount?;
    /**
     * @stability stable
     */
    get ownerAccount(): string;
    /**
     * @stability stable
     */
    set ownerAccount(value: string);
    /**
     * @stability stable
     */
    resetOwnerAccount(): void;
    /**
     * @stability stable
     */
    get ownerAccountInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _preferredMaintenanceWindow?;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    set preferredMaintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindowInput(): string | undefined;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | undefined;
    private _skipFinalSnapshot?;
    /**
     * @stability stable
     */
    get skipFinalSnapshot(): boolean;
    /**
     * @stability stable
     */
    set skipFinalSnapshot(value: boolean);
    /**
     * @stability stable
     */
    resetSkipFinalSnapshot(): void;
    /**
     * @stability stable
     */
    get skipFinalSnapshotInput(): boolean | undefined;
    private _snapshotClusterIdentifier?;
    /**
     * @stability stable
     */
    get snapshotClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotClusterIdentifierInput(): string | undefined;
    private _snapshotIdentifier?;
    /**
     * @stability stable
     */
    get snapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotIdentifierInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _logging?;
    /**
     * @stability stable
     */
    get logging(): RedshiftClusterLogging[];
    /**
     * @stability stable
     */
    set logging(value: RedshiftClusterLogging[]);
    /**
     * @stability stable
     */
    resetLogging(): void;
    /**
     * @stability stable
     */
    get loggingInput(): RedshiftClusterLogging[] | undefined;
    private _snapshotCopy?;
    /**
     * @stability stable
     */
    get snapshotCopy(): RedshiftClusterSnapshotCopy[];
    /**
     * @stability stable
     */
    set snapshotCopy(value: RedshiftClusterSnapshotCopy[]);
    /**
     * @stability stable
     */
    resetSnapshotCopy(): void;
    /**
     * @stability stable
     */
    get snapshotCopyInput(): RedshiftClusterSnapshotCopy[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): RedshiftClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: RedshiftClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RedshiftClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
