import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServicequotasServiceQuotaConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#quota_code ServicequotasServiceQuota#quota_code}.
     *
     * @stability stable
     */
    readonly quotaCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#service_code ServicequotasServiceQuota#service_code}.
     *
     * @stability stable
     */
    readonly serviceCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#value ServicequotasServiceQuota#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html aws_servicequotas_service_quota}.
 *
 * @stability stable
 */
export declare class ServicequotasServiceQuota extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html aws_servicequotas_service_quota} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServicequotasServiceQuotaConfig);
    /**
     * @stability stable
     */
    get adjustable(): boolean;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get defaultValue(): number;
    /**
     * @stability stable
     */
    get id(): string;
    private _quotaCode;
    /**
     * @stability stable
     */
    get quotaCode(): string;
    /**
     * @stability stable
     */
    set quotaCode(value: string);
    /**
     * @stability stable
     */
    get quotaCodeInput(): string;
    /**
     * @stability stable
     */
    get quotaName(): string;
    /**
     * @stability stable
     */
    get requestId(): string;
    /**
     * @stability stable
     */
    get requestStatus(): string;
    private _serviceCode;
    /**
     * @stability stable
     */
    get serviceCode(): string;
    /**
     * @stability stable
     */
    set serviceCode(value: string);
    /**
     * @stability stable
     */
    get serviceCodeInput(): string;
    /**
     * @stability stable
     */
    get serviceName(): string;
    private _value;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
