import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SpotFleetRequestConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#allocation_strategy SpotFleetRequest#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#excess_capacity_termination_policy SpotFleetRequest#excess_capacity_termination_policy}.
     *
     * @stability stable
     */
    readonly excessCapacityTerminationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#fleet_type SpotFleetRequest#fleet_type}.
     *
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_fleet_role SpotFleetRequest#iam_fleet_role}.
     *
     * @stability stable
     */
    readonly iamFleetRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_interruption_behaviour SpotFleetRequest#instance_interruption_behaviour}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehaviour?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_pools_to_use_count SpotFleetRequest#instance_pools_to_use_count}.
     *
     * @stability stable
     */
    readonly instancePoolsToUseCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#load_balancers SpotFleetRequest#load_balancers}.
     *
     * @stability stable
     */
    readonly loadBalancers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#replace_unhealthy_instances SpotFleetRequest#replace_unhealthy_instances}.
     *
     * @stability stable
     */
    readonly replaceUnhealthyInstances?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
     *
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags SpotFleetRequest#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags_all SpotFleetRequest#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#target_capacity SpotFleetRequest#target_capacity}.
     *
     * @stability stable
     */
    readonly targetCapacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#target_group_arns SpotFleetRequest#target_group_arns}.
     *
     * @stability stable
     */
    readonly targetGroupArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#terminate_instances_with_expiration SpotFleetRequest#terminate_instances_with_expiration}.
     *
     * @stability stable
     */
    readonly terminateInstancesWithExpiration?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#valid_from SpotFleetRequest#valid_from}.
     *
     * @stability stable
     */
    readonly validFrom?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#valid_until SpotFleetRequest#valid_until}.
     *
     * @stability stable
     */
    readonly validUntil?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#wait_for_fulfillment SpotFleetRequest#wait_for_fulfillment}.
     *
     * @stability stable
     */
    readonly waitForFulfillment?: boolean;
    /**
     * launch_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_specification SpotFleetRequest#launch_specification}
     *
     * @stability stable
     */
    readonly launchSpecification?: SpotFleetRequestLaunchSpecification[];
    /**
     * launch_template_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_template_config SpotFleetRequest#launch_template_config}
     *
     * @stability stable
     */
    readonly launchTemplateConfig?: SpotFleetRequestLaunchTemplateConfig[];
    /**
     * spot_maintenance_strategies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_maintenance_strategies SpotFleetRequest#spot_maintenance_strategies}
     *
     * @stability stable
     */
    readonly spotMaintenanceStrategies?: SpotFleetRequestSpotMaintenanceStrategies[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#timeouts SpotFleetRequest#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SpotFleetRequestTimeouts;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationEbsBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete_on_termination SpotFleetRequest#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#device_name SpotFleetRequest#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#encrypted SpotFleetRequest#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iops SpotFleetRequest#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#kms_key_id SpotFleetRequest#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#snapshot_id SpotFleetRequest#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#throughput SpotFleetRequest#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_size SpotFleetRequest#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_type SpotFleetRequest#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationEphemeralBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#device_name SpotFleetRequest#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#virtual_name SpotFleetRequest#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationRootBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete_on_termination SpotFleetRequest#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#encrypted SpotFleetRequest#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iops SpotFleetRequest#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#kms_key_id SpotFleetRequest#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#throughput SpotFleetRequest#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_size SpotFleetRequest#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_type SpotFleetRequest#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ami SpotFleetRequest#ami}.
     *
     * @stability stable
     */
    readonly ami: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#associate_public_ip_address SpotFleetRequest#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#availability_zone SpotFleetRequest#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ebs_optimized SpotFleetRequest#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_instance_profile SpotFleetRequest#iam_instance_profile}.
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_instance_profile_arn SpotFleetRequest#iam_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly iamInstanceProfileArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_type SpotFleetRequest#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#key_name SpotFleetRequest#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#monitoring SpotFleetRequest#monitoring}.
     *
     * @stability stable
     */
    readonly monitoring?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#placement_group SpotFleetRequest#placement_group}.
     *
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#placement_tenancy SpotFleetRequest#placement_tenancy}.
     *
     * @stability stable
     */
    readonly placementTenancy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
     *
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#subnet_id SpotFleetRequest#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags SpotFleetRequest#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#user_data SpotFleetRequest#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#vpc_security_group_ids SpotFleetRequest#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#weighted_capacity SpotFleetRequest#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: string;
    /**
     * ebs_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ebs_block_device SpotFleetRequest#ebs_block_device}
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: SpotFleetRequestLaunchSpecificationEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ephemeral_block_device SpotFleetRequest#ephemeral_block_device}
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: SpotFleetRequestLaunchSpecificationEphemeralBlockDevice[];
    /**
     * root_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#root_block_device SpotFleetRequest#root_block_device}
     *
     * @stability stable
     */
    readonly rootBlockDevice?: SpotFleetRequestLaunchSpecificationRootBlockDevice[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#id SpotFleetRequest#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#name SpotFleetRequest#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#version SpotFleetRequest#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfigOverrides {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#availability_zone SpotFleetRequest#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_type SpotFleetRequest#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#priority SpotFleetRequest#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
     *
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#subnet_id SpotFleetRequest#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#weighted_capacity SpotFleetRequest#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfig {
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_template_specification SpotFleetRequest#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification[];
    /**
     * overrides block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#overrides SpotFleetRequest#overrides}
     *
     * @stability stable
     */
    readonly overrides?: SpotFleetRequestLaunchTemplateConfigOverrides[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#replacement_strategy SpotFleetRequest#replacement_strategy}.
     *
     * @stability stable
     */
    readonly replacementStrategy?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestSpotMaintenanceStrategies {
    /**
     * capacity_rebalance block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#capacity_rebalance SpotFleetRequest#capacity_rebalance}
     *
     * @stability stable
     */
    readonly capacityRebalance?: SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#create SpotFleetRequest#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete SpotFleetRequest#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html aws_spot_fleet_request}.
 *
 * @stability stable
 */
export declare class SpotFleetRequest extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html aws_spot_fleet_request} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SpotFleetRequestConfig);
    private _allocationStrategy?;
    /**
     * @stability stable
     */
    get allocationStrategy(): string;
    /**
     * @stability stable
     */
    set allocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get allocationStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get clientToken(): string;
    private _excessCapacityTerminationPolicy?;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicy(): string;
    /**
     * @stability stable
     */
    set excessCapacityTerminationPolicy(value: string);
    /**
     * @stability stable
     */
    resetExcessCapacityTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicyInput(): string | undefined;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    private _iamFleetRole;
    /**
     * @stability stable
     */
    get iamFleetRole(): string;
    /**
     * @stability stable
     */
    set iamFleetRole(value: string);
    /**
     * @stability stable
     */
    get iamFleetRoleInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceInterruptionBehaviour?;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviour(): string;
    /**
     * @stability stable
     */
    set instanceInterruptionBehaviour(value: string);
    /**
     * @stability stable
     */
    resetInstanceInterruptionBehaviour(): void;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviourInput(): string | undefined;
    private _instancePoolsToUseCount?;
    /**
     * @stability stable
     */
    get instancePoolsToUseCount(): number;
    /**
     * @stability stable
     */
    set instancePoolsToUseCount(value: number);
    /**
     * @stability stable
     */
    resetInstancePoolsToUseCount(): void;
    /**
     * @stability stable
     */
    get instancePoolsToUseCountInput(): number | undefined;
    private _loadBalancers?;
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    /**
     * @stability stable
     */
    set loadBalancers(value: string[]);
    /**
     * @stability stable
     */
    resetLoadBalancers(): void;
    /**
     * @stability stable
     */
    get loadBalancersInput(): string[] | undefined;
    private _replaceUnhealthyInstances?;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstances(): boolean;
    /**
     * @stability stable
     */
    set replaceUnhealthyInstances(value: boolean);
    /**
     * @stability stable
     */
    resetReplaceUnhealthyInstances(): void;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstancesInput(): boolean | undefined;
    private _spotPrice?;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    set spotPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotPrice(): void;
    /**
     * @stability stable
     */
    get spotPriceInput(): string | undefined;
    /**
     * @stability stable
     */
    get spotRequestState(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _targetCapacity;
    /**
     * @stability stable
     */
    get targetCapacity(): number;
    /**
     * @stability stable
     */
    set targetCapacity(value: number);
    /**
     * @stability stable
     */
    get targetCapacityInput(): number;
    private _targetGroupArns?;
    /**
     * @stability stable
     */
    get targetGroupArns(): string[];
    /**
     * @stability stable
     */
    set targetGroupArns(value: string[]);
    /**
     * @stability stable
     */
    resetTargetGroupArns(): void;
    /**
     * @stability stable
     */
    get targetGroupArnsInput(): string[] | undefined;
    private _terminateInstancesWithExpiration?;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpiration(): boolean;
    /**
     * @stability stable
     */
    set terminateInstancesWithExpiration(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstancesWithExpiration(): void;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpirationInput(): boolean | undefined;
    private _validFrom?;
    /**
     * @stability stable
     */
    get validFrom(): string;
    /**
     * @stability stable
     */
    set validFrom(value: string);
    /**
     * @stability stable
     */
    resetValidFrom(): void;
    /**
     * @stability stable
     */
    get validFromInput(): string | undefined;
    private _validUntil?;
    /**
     * @stability stable
     */
    get validUntil(): string;
    /**
     * @stability stable
     */
    set validUntil(value: string);
    /**
     * @stability stable
     */
    resetValidUntil(): void;
    /**
     * @stability stable
     */
    get validUntilInput(): string | undefined;
    private _waitForFulfillment?;
    /**
     * @stability stable
     */
    get waitForFulfillment(): boolean;
    /**
     * @stability stable
     */
    set waitForFulfillment(value: boolean);
    /**
     * @stability stable
     */
    resetWaitForFulfillment(): void;
    /**
     * @stability stable
     */
    get waitForFulfillmentInput(): boolean | undefined;
    private _launchSpecification?;
    /**
     * @stability stable
     */
    get launchSpecification(): SpotFleetRequestLaunchSpecification[];
    /**
     * @stability stable
     */
    set launchSpecification(value: SpotFleetRequestLaunchSpecification[]);
    /**
     * @stability stable
     */
    resetLaunchSpecification(): void;
    /**
     * @stability stable
     */
    get launchSpecificationInput(): SpotFleetRequestLaunchSpecification[] | undefined;
    private _launchTemplateConfig?;
    /**
     * @stability stable
     */
    get launchTemplateConfig(): SpotFleetRequestLaunchTemplateConfig[];
    /**
     * @stability stable
     */
    set launchTemplateConfig(value: SpotFleetRequestLaunchTemplateConfig[]);
    /**
     * @stability stable
     */
    resetLaunchTemplateConfig(): void;
    /**
     * @stability stable
     */
    get launchTemplateConfigInput(): SpotFleetRequestLaunchTemplateConfig[] | undefined;
    private _spotMaintenanceStrategies?;
    /**
     * @stability stable
     */
    get spotMaintenanceStrategies(): SpotFleetRequestSpotMaintenanceStrategies[];
    /**
     * @stability stable
     */
    set spotMaintenanceStrategies(value: SpotFleetRequestSpotMaintenanceStrategies[]);
    /**
     * @stability stable
     */
    resetSpotMaintenanceStrategies(): void;
    /**
     * @stability stable
     */
    get spotMaintenanceStrategiesInput(): SpotFleetRequestSpotMaintenanceStrategies[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SpotFleetRequestTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SpotFleetRequestTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SpotFleetRequestTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
